"""__init__.py"""

import sys
from typing import TYPE_CHECKING

from lazy_imports import LazyImporter


if TYPE_CHECKING:
    from ._1575 import Command
    from ._1576 import AnalysisRunInformation
    from ._1577 import DispatcherHelper
    from ._1578 import EnvironmentSummary
    from ._1579 import ExternalFullFEFileOption
    from ._1580 import FileHistory
    from ._1581 import FileHistoryItem
    from ._1582 import FolderMonitor
    from ._1584 import IndependentReportablePropertiesBase
    from ._1585 import InputNamePrompter
    from ._1586 import IntegerRange
    from ._1587 import LoadCaseOverrideOption
    from ._1588 import MethodOutcome
    from ._1589 import MethodOutcomeWithResult
    from ._1590 import MKLVersion
    from ._1591 import NumberFormatInfoSummary
    from ._1592 import PerMachineSettings
    from ._1593 import PersistentSingleton
    from ._1594 import ProgramSettings
    from ._1595 import PushbulletSettings
    from ._1596 import RoundingMethods
    from ._1597 import SelectableFolder
    from ._1598 import SystemDirectory
    from ._1599 import SystemDirectoryPopulator
else:
    import_structure = {
        "_1575": ["Command"],
        "_1576": ["AnalysisRunInformation"],
        "_1577": ["DispatcherHelper"],
        "_1578": ["EnvironmentSummary"],
        "_1579": ["ExternalFullFEFileOption"],
        "_1580": ["FileHistory"],
        "_1581": ["FileHistoryItem"],
        "_1582": ["FolderMonitor"],
        "_1584": ["IndependentReportablePropertiesBase"],
        "_1585": ["InputNamePrompter"],
        "_1586": ["IntegerRange"],
        "_1587": ["LoadCaseOverrideOption"],
        "_1588": ["MethodOutcome"],
        "_1589": ["MethodOutcomeWithResult"],
        "_1590": ["MKLVersion"],
        "_1591": ["NumberFormatInfoSummary"],
        "_1592": ["PerMachineSettings"],
        "_1593": ["PersistentSingleton"],
        "_1594": ["ProgramSettings"],
        "_1595": ["PushbulletSettings"],
        "_1596": ["RoundingMethods"],
        "_1597": ["SelectableFolder"],
        "_1598": ["SystemDirectory"],
        "_1599": ["SystemDirectoryPopulator"],
    }

    sys.modules[__name__] = LazyImporter(
        __name__,
        globals()["__file__"],
        import_structure,
    )

__all__ = (
    "Command",
    "AnalysisRunInformation",
    "DispatcherHelper",
    "EnvironmentSummary",
    "ExternalFullFEFileOption",
    "FileHistory",
    "FileHistoryItem",
    "FolderMonitor",
    "IndependentReportablePropertiesBase",
    "InputNamePrompter",
    "IntegerRange",
    "LoadCaseOverrideOption",
    "MethodOutcome",
    "MethodOutcomeWithResult",
    "MKLVersion",
    "NumberFormatInfoSummary",
    "PerMachineSettings",
    "PersistentSingleton",
    "ProgramSettings",
    "PushbulletSettings",
    "RoundingMethods",
    "SelectableFolder",
    "SystemDirectory",
    "SystemDirectoryPopulator",
)
